%{

#include <stdio.h>
#include <string.h>
#include "cmdbuf.h"

extern int yylineno;
extern int yylex();
int yyerror(char *s);

ArgStruct arg;
CmdParseBuf cmdbuf;
list<CmdParseBuf> cmdlist;

void ClearCmdParseBuf(CmdParseBuf &cmdbuf);


/*#define DEBUG*/

%}

%start inputfile

%union{
    int    ival;
    double dval;
    char   sval[32];
}


%token <sval> KEYWORD  PARAMETER
%token <ival> ASSIGN
%token <dval> REAL
%token <sval> STRING
%token <ival> COMMENT BLANK ERROR



%%

inputfile
    :	command
        {cmdbuf.lineno = yylineno;}
    |	inputfile command
        {cmdbuf.lineno = yylineno;}
    ;

command
    :	KEYWORD assign 
{ 
#ifdef DEBUG 
	printf("--YACC command --");
#endif    	    
 	strcpy(cmdbuf.KeyWord,$1);
  	cmdlist.push_back(cmdbuf); 
	ClearCmdParseBuf(cmdbuf);
}	
     | 	COMMENT
     |  BLANK	
     ;	
     
     
assign 
     : assign PARAMETER '=' REAL 
{  
#ifdef DEBUG 
	printf("--PARAMETER ASSIGN REAL--");
#endif  	   	  		    	    
	strcpy(arg.label,$2);
        arg.argtype=DOUBLE;
	arg.argvalue.dval=$4;
	cmdbuf.arglist.push_back(arg);
}
     | PARAMETER '=' REAL  
{  
#ifdef DEBUG 
	printf("--PARAMETER ASSIGN REAL--");
#endif  	   	  		    	    
	strcpy(arg.label,$1);
        arg.argtype=DOUBLE;
	arg.argvalue.dval=$3;
	cmdbuf.arglist.push_back(arg);
}
     | assign PARAMETER '=' STRING 
{  
#ifdef DEBUG 
	printf("--PARAMETER ASSIGN STRING--");
#endif  	   	  		    	    
	strcpy(arg.label,$2);
        arg.argtype=CHARS;
	strcpy(arg.argvalue.sval,$4);
	cmdbuf.arglist.push_back(arg);
}
     | PARAMETER '=' STRING
{  
#ifdef DEBUG 
	printf("--PARAMETER ASSIGN STRING--");
#endif  	   	  		    	    
	strcpy(arg.label,$1);
        arg.argtype=CHARS;
	strcpy(arg.argvalue.sval,$3);
	cmdbuf.arglist.push_back(arg);
}
     ;    

%%

int yyerror(char *s)
{
   printf("line %d unrecognized \"%s\": %s\n",yylineno,yylval.sval,s);
   return 0;
}

void ClearCmdParseBuf(CmdParseBuf &cmdbuf)
{
   strcpy(cmdbuf.KeyWord,"");
   cmdbuf.arglist.clear();    
}   