#ifndef _imhdm_h_
#define _imhdm_h_


#include "solver.h"
#include "petscksp.h"
#include "poisson.h"

class Im_HDM_Solver : virtual public POISSON
{
  private:	
	//petsc variables
	int  N;
	Vec  b,x;
	Mat  A;
	KSP  ksp; /* linear solver context */
	PC   pc; /* preconditioner context */
	ZONE    *pzone;
	SMCZone *pzonedata; 
  public:
  	int	init_solver();
	int     do_solve(SolveDefine &);
	int     destroy_solver(); 
	Im_HDM_Solver() {}	        
}; 

#endif
