#ifndef _ntddm_h_
#define _ntddm_h_

#include "solver.h"
#include "petscsnes.h"
class Nt_DDM_Solver : virtual public BSolver
{
  private:
  	int            N;	     // the scale if matrix
  	int            total_nodes;  //	
  	SNES           snes;         // nonlinear solver context
	KSP            ksp;          // linear solver context 
	PC             pc;           // preconditioner context 
	Vec            x,r;          // solution, residual vectors 
	Mat            J;            // Jacobian matrix 
	vector<int>    zofs;         // the offset value of each zone in solution vector  
	PetscInt       its;          // iteration number
	PetscReal      norm;
	
	double *a1,*a2,*a3;	     //for fast least-squares computation
   	SNESConvergedReason reason;     
   	void 	solution_update(Vec &);      
  public:
  	int	init_solver();
	int     do_solve(SolveDefine &);
	int     destroy_solver(); 
	Nt_DDM_Solver():N(0),total_nodes(0) {}	
  friend PetscErrorCode form_function_pn(SNES,Vec,Vec ,void *);
  friend PetscErrorCode form_jacobian_pn(SNES,Vec,Mat*,Mat*,MatStructure *,void *);	        
};

#endif
