#ifndef _poisson_h_
#define _poisson_h_


#include "solver.h"
#include "petscksp.h"

class POISSON : virtual public BSolver
{
  protected:
 
	//for solve Ax=b
	int  N;    //the scale if matrix 
	Vec  b,x;
	Mat  A;
	KSP  ksp;
	PC   pc; 

	//for fast least-squares computation
	double *a1,*a2,*a3;

	void init_poisson();
	void do_poisson();	
	void destroy_poisson(); 
	
	POISSON():N(0) {}
};

#endif
