/*-----------------------------------------------------------------------------

 FILE:	   xgraph.h

 PROJECT:

 AUTHOR:   Kevin M. Kramer
	   J. Joshua Feng

 REVISION HISTORY
 DATE	   INITIALS   DESCRIPTION
 --------  --------   --------------------------------------------------------
 12/15/93    KMK      initial implementation
 02/04/97    JJF      Modification (Adding LUT functions)

 DESCRIPTION:

 This module contains functions implement a small subset of the Borland BGI
 functions under X windows. Hence this module should not be included when
 compiling under Borland C++ enviroments.

-----------------------------------------------------------------------------*/

#ifndef __xgraph_h
#define __xgraph_h


#define GR_BLACK	     0
#define GR_BLUE		     1
#define GR_GREEN	     2
#define GR_CYAN		     3
#define GR_RED		     4
#define GR_MAGENTA	     5
#define GR_BROWN	     6
#define GR_LIGHTGRAY	     7
#define GR_DARKGRAY	     8
#define GR_LIGHTBLUE	     9
#define GR_LIGHTGREEN	     10
#define GR_LIGHTCYAN	     11
#define GR_LIGHTRED	     12
#define GR_LIGHTMAGENTA	     13
#define GR_YELLOW	     14
#define GR_WHITE	     15

#define DETECT		  0

#define PS_SOLID	  1

#define EXPOSE		  0
#define CONFIGURENOTIFY	  1
#define KEYPRESS	  2
#define BUTTONPRESS	  3
#define OTHEREVENT	  4
#define BACKSPACE	  5
#define ESCAPE		  6
#define LEFTARROW	  7
#define RIGHTARROW	  8
#define UPARROW		  9
#define DOWNARROW	  10

#define grOk		  0
#define grNoInitGraph	 -1
#define grNotDetected	 -2
#define grFileNotFound	 -3
#define grInvalidDriver	 -4
#define grNoLoadMem	 -5

typedef void  (*PFREDRAW) ();

void  GRPrintOpen     (char *, int = 20);
void  GRPrintClose    (void);
void  GRInitGraphics  (int = 7, int = 14);
void  GRFreeGraphics  (void);
void  GROpenGraphWin  (char *, char *, int, int, int, int, PFREDRAW);
void  GRClearGraphWin (void);
void  GRSetColor      (int);
void  GRSetFillColor  (int, int = PS_SOLID);
void  GRPutPixel      (int, int, int);
void  GRLine	      (int, int, int, int);
void  GRCircle	      (int, int, int);
void  GRDrawPoly      (int, int *);
void  GRFillPoly      (int, int *);
void  GRText	      (int, int, char *);
int   GRGetMaxX	      (void);
int   GRGetMaxY	      (void);
int   GRSetLUT	      (int);
void  setcmdargs      (int, char **);
void  flushdisplay    (void);
int   getevent	      (short int *, int *, int *);

#endif /* __xgraph_h */
