#include <stdio.h>
#include <stdlib.h>
#include "ctrl.h"

extern int yyparse();
extern FILE* yyin;

int main(int argc, char ** args)
{
	PetscInitialize(&argc,&args,PETSC_NULL,PETSC_NULL);

	if(argc<2)
	{
		printf("usage: gss cmdfile petsc_option\n");
		exit(0);
	}

	yyin=fopen(args[1],"r");
 	if(yyparse())
 	 { printf("input parse interrupt.\n"); exit(0); }

  	fclose(yyin);

	SolveControl *solver= new SolveControl;
	if(solver->static_config(cmdlist)) exit(0);
 	if(solver->run_control(cmdlist)) exit(0);
	delete solver;
        PetscFinalize();
}
