#include "exhdm.h"
#include <assert.h>

int Ex_HDM_Solver::init_solver()
{
	printf("HDM solver init...done\n");
}
	
int Ex_HDM_Solver::destroy_solver()
{
	
}
	
int Ex_HDM_Solver::do_solve(SolveDefine &sv)
{
	if(sv.Type!=TRANSIENT)
	{
		printf("Explicit HDM mthod can only do TRANSIENT computing\n");
		return 1 ;
	}	 
	
	printf("WARNING: Explicit HDM method is not recommend to use.\n");
	printf("         We can't ensure numerical stability!\n");
	 
	SMCZone *pzonedata; 
	int smcz_num = 0;
	for(int i=0;i<zone_num;i++)
	  if(zonedata[i]->material_type == semiconductor)
	  {
	  	pzonedata = dynamic_cast< SMCZone * >(zonedata[i]);
	  	smcz_num++;
	  }
	if(smcz_num !=1)
	{
		printf("Explicit HDM mthod can only deal with one semiconductor zone\n");
		return 1 ;
	}
		 
	pzonedata->set_flux_function(sv.FluxFunc);	
    	
	init_poisson();
	bc.Set_Vapp(0);
	do_poisson();
	
	while(clock<sv.TStop)
	{
	 	bc.Set_Vapp(clock);
	 	if(sv.Reconstruct==FirstOrder)
	 		pzonedata->first_order_reconst(bc,Carrier);
	 	if(sv.Reconstruct==SecondOrder)
	  		pzonedata->MUSCL_reconst(bc,Carrier);
	  	dt=sv.CFL*pzonedata->build_flux(bc,Carrier);
	 	pzonedata->source_implicit_update(dt/2);
		pzonedata->Flux_explicit_update(bc,Carrier,dt);
		pzonedata->set_ohmic_boundary(bc,Carrier);
		do_poisson();	
		pzonedata->source_implicit_update(dt/2);
		clock+=dt;
		printf("t = %e\n",clock);
	}	
	destroy_poisson();
	return 0;
	
}
