#include "exhdm.h"
extern "C" 
{
 extern int dgesv_(int *n, int *nrhs, double *da, int *lda, int *ipivot, 
                   double *db, int *ldb, int *info);
}     
  
//------------------------------------------------------------------------------------
void SMCZone::get_source_matrix(matrix_double &S,int i,int carrier)
{
	  double U,taow,taop,q,m,n;
	  if(carrier==N_Type)
	  {
	  	U = mt->recombination(fs[i].Qp.v[0],fs[i].Qn.v[0],fs[i].Na,fs[i].Nd,fs[i].T);
	  	n = fs[i].Qn.v[0];
	  	m = mt->mass_elec();
	  	taow = mt->taow_elec();
	  	taop = mt->taop_elec(fs[i].Na,fs[i].Nd,fs[i].T);
	  	q=-1;
	  }
	  if(carrier==P_Type)
	  {	
	  	U = mt->recombination(fs[i].Qp.v[0],fs[i].Qn.v[0],fs[i].Na,fs[i].Nd,fs[i].T);
	  	n = fs[i].Qp.v[0];
	  	m = mt->mass_hole();
	  	taow = mt->taow_hole();
	  	taop = mt->taop_hole(fs[i].Na,fs[i].Nd,fs[i].T);
	  	q = 1;
	  }	

	  S.m[0] = -U/n;
	  S.m[1] = 0;
	  S.m[2] = 0;
	  S.m[3] = 0;
	  
	  S.m[4] = q*aux[i].Ex;
	  S.m[5] = -1/taop-U/n;
	  S.m[6] = 0;
	  S.m[7] = 0;
	  
	  S.m[8]  = q*aux[i].Ey;
	  S.m[9]  = 0;
	  S.m[10] = -1/taop-U/n;
	  S.m[11] = 0;
	  
	  S.m[12] = 1.5*mt->k*fs[i].T/taow;
	  S.m[13] = q/m*aux[i].Ex;
	  S.m[14] = q/m*aux[i].Ey;
	  S.m[15] = -1/taow-U/n;
	  //Set_Matrix_zero(S);
}

void SMCZone::source_implicit_update(double dt)
{
	int NN=4,NRHS=1,LDA=NN,LDB=NN,INFO;
	matrix_double S,I,A;
	vector_double b;
	int IPIVOT[4];
	Set_Matrix_I(I);
	
	for(int i=0;i<node_num;i++)
          //ֻڵ͵ڶ߽紦
          //if(pnode[i].BCIndex==0||bc[pnode[i].BCIndex-1].BCType==SoildWall) 
          {
          	get_source_matrix(S,i,N_Type);
	        b=dt*S*fs[i].Qn;
	        A=I-0.5*dt*S;
	        matrix_transport(A);
	        dgesv_(&NN,&NRHS, A.m, &LDA, IPIVOT,b.v, &LDB,&INFO);
	        fs[i].Qn = fs[i].Qn + b;
		
		get_source_matrix(S,i,P_Type);
	        b=dt*S*fs[i].Qp;
	        A=I-0.5*dt*S;
	        matrix_transport(A);
	        dgesv_(&NN,&NRHS, A.m, &LDA, IPIVOT,b.v, &LDB,&INFO);
	        fs[i].Qp = fs[i].Qp + b;
	   }  
}

void SMCZone::source_explicit_update(double dt)
{
	
	matrix_double S,I;
	vector_double b;
	Set_Matrix_I(I);
	for(int i=0;i<node_num;i++)
          //if(pnode[i].BCIndex==0||bc[pnode[i].BCIndex-1].BCType==SoildWall) 
          {
          	get_source_matrix(S,i,N_Type);
	        fs[i].Qn=(I+dt*S)*fs[i].Qn;
	        
	        get_source_matrix(S,i,P_Type);
	        fs[i].Qp=(I+dt*S)*fs[i].Qp;
          }  
}
